-- Unmoving plaid by using shader

local lg = love.graphics

local frame1
local frame2
local plaid
local canvas
local shader

function love.load(args)
  frame1 = lg.newImage('using-shader/frame1.png')
  frame2 = lg.newImage('using-shader/frame2.png')
  plaid = lg.newImage('plaid.png')

  -- Fill the canvas with copies of the plaid
  canvas = lg.newCanvas()
  lg.setCanvas(canvas)
  for y = 1, canvas:getHeight()-1, plaid:getHeight() do
    for x = 1, canvas:getWidth()-1, plaid:getWidth() do
      lg.draw(plaid, x, y)
    end
  end
  lg.setCanvas()

  shader = lg.newShader(
[[
extern Image canvas;
vec4 effect(vec4 colour, Image img, vec2 imgpos, vec2 scrpos)
{
    return vec4(Texel(canvas, scrpos
 / vec2(love_ScreenSize)
).xyz, Texel(img, imgpos).w);
}
]])
end

local timer = 0

function love.update(dt)
  timer = timer + dt
  if timer >= 1 then timer = timer - 1 end
end


function love.draw()
  shader:send("canvas", canvas)
  lg.setShader(shader)
  if timer < 0.5 then lg.draw(frame1) else lg.draw(frame2) end
  lg.setShader()
end
